import java.io.*;

/**
 * This class takes input English and Picture files
 * and produces equivalent ones that have no nested loops
 */
public class LoopExpander extends ElemOpExpander{
	int _lenOfSEO = 0;
    
    /**
     * 
     */
	LoopExpander(
		String 	filePrefixIn,
		String 	filePrefixOut)
	{
		super(filePrefixIn, filePrefixOut, 0/*numGitsIn*/);
		
				
		try{
			openFiles();

			String lineName = "";
			SEO_reader	reader=null;
			int loopDepth=0;
			int lineNum, lineNumStart=0, reps, loopNum;
			while(_englishIn.hasNext()){
				lineName = _englishIn.next();
				if(lineName.equals("LOOP")){
					lineNum = _englishIn.nextInt();
					_englishIn.next();//skip "REPS:"
					reps = _englishIn.nextInt();
					if(loopDepth==0){
						Throw.If(_knowNumBitsIn==false, 
							"must measure number of bits before first loop");
						reader = new SEO_reader(_englishIn, _numBitsIn);
						lineNumStart = lineNum;
					}
					reader.getLineList().addLOOP(lineNum-lineNumStart, reps);
					_pictureIn.nextLine();
					loopDepth++;
				}else if(lineName.equals("NEXT")){
					loopNum = _englishIn.nextInt();
					reader.getLineList().addNEXT(loopNum-lineNumStart);
					_pictureIn.nextLine();
					loopDepth--;
					Throw.If(loopDepth<0, "negative loop depth");
					if(loopDepth==0){
						 SEO_writer writer = new SEO_writer(
								 _englishOut, 
								 _pictureOut,
								 new CktEmbedder(getNumBitsOut()));
						 writer.setGitsMonitor(_gm);

						 _lenOfSEO += 
							 reader.getLineList().writeYourself(writer);
					}
				}else{//not LOOP or NEXT
					if(loopDepth==0){
						String	endOfEngLine = _englishIn.nextLine();
						echoEngAndPicLines(lineName + "\t" + endOfEngLine);
						_lenOfSEO++;
					}else{
						reader.readStore(lineName);
						_pictureIn.nextLine();
					}
				}
			}
			closeFiles();
		}
		catch(FileNotFoundException ex){
			System.out.println("\n" + ex.toString());
		}
	}
    /**
	 * 
	 */
	public int getNumGitsOut(){
		//should not depend on _numBitsIn
		return _numGitsIn;		
	}
	/**
	 *
	 */
	public int getLenOfSEO() {
		return _lenOfSEO;
	}

 }
