import java.io.*;

/**
 * This class's main() method is the applet sans gui.
 * The class MultiCNotExpander doesn't write a Log File
 * or count the number of elementary operations out. This one does.
 */
public class MultiCNotExpanderMain {	
	private MultiCNotExpander	_expander;
	private int		_lenOfSEO;
	/**
	 *
	 */
	public MultiCNotExpanderMain(
			String 	filePrefixIn,
			String 	filePrefixOut,
			int numGitsIn,
			int compiMode)
	{
		
		_expander = new MultiCNotExpander(
				filePrefixIn,
				filePrefixOut,
				numGitsIn,
				compiMode);

    	
    	SEO_countOnlyReader	reader = new SEO_countOnlyReader(
    	    filePrefixOut);
    	_lenOfSEO = reader.getLenOfSEO();
    	//System.out.println(reader);
    	
    	
    	PrintWriter   logOut = null;
    	try{
	        File  logFile = new File(filePrefixOut + "_log.txt");
	        logOut = new PrintWriter(logFile);
    	}
    	catch(FileNotFoundException ex){
    		System.out.println("\n" + ex.toString());
        }
    	logOut.println("Inputs:");
        logOut.println("Prefix for Input Files = " + filePrefixIn);
        logOut.println("Prefix for Output Files = " + filePrefixOut);
        logOut.println("Number of Grounded Bits In = " + numGitsIn);
        switch(compiMode){
	        case(MultiCNotExpander.TOFFOLIS):
	        	logOut.println("Compilation Mode = TOFFOLIS");
	        	break;
	        default:
	        	Throw.If(true, "unlisted compilation mode");
        }
        logOut.println(filePrefixIn + "_eng.txt");
        logOut.println(filePrefixIn + "_pic.txt");
        
        logOut.println("");
        logOut.println("Outputs:");
        logOut.println("Number of Non-grounded Bits = " + 
        		_expander.getNumNonGits());
        logOut.println("Number of Grounded Bits Out = " + 
        		_expander.getNumGitsOut());
        logOut.println("Number of Elem. Ops. Out = " + _lenOfSEO);
 //       logOut.printf("Error = %e\n", _error);
        logOut.println(filePrefixOut + "_eng.txt");
        logOut.println(filePrefixOut + "_pic.txt");
        logOut.println(filePrefixOut + "_log.txt");

        logOut.close();
   	
	}	
	/**
	 *
	 */
	public MultiCNotExpander  getExpander() {
		return _expander;
	}
	/**
	 *
	 */
	public int getLenOfSEO() {
		return _lenOfSEO;
	}
	/**
	 *
	 */
    public static void main(String[] args){
    	
//	   String 	filePrefixIn = "one_in";
//	   String 	filePrefixOut = "one_out";
	   String 	filePrefixIn = "all_in";
	   String 	filePrefixOut = "all_out";

	   int	numGitsIn = 1;
	   int compiMode = MultiCNotExpander.TOFFOLIS;
 	   
	   MultiCNotExpanderMain m = new MultiCNotExpanderMain(
			filePrefixIn, filePrefixOut, numGitsIn, compiMode);
	   
	   
	   SEO_readerMu	readerIn = new SEO_readerMu(
			   filePrefixIn,
			   m.getExpander().getNumBitsIn(),  
			   false); // useSparse
	   //System.out.println("Input");System.out.println(readerIn);
	   	   
	   SEO_readerMu	readerOut = new SEO_readerMu(
			   filePrefixOut,
			   m.getExpander().getNumBitsOut(), 
			   false); // useSparse
	   //System.out.println("Output");System.out.println(readerOut);

	   double error = 0.0;
	   int row, col;
	   int numNonGits = m.getExpander().getNumNonGits();
	   int numRows = 1<<numNonGits;
	   for(row=0; row<numRows; row++){
		   for(col=0; col<numRows; col++){
			   	error += Complex.abs(Complex.minus(
    					readerOut.getEntry(row,col), 
    					readerIn.getEntry(row,col)
    					));
		   }
	   }
    	
	   System.out.printf("Error = %e\n", error);

    }
}
