import java.io.*;

/**
 * This class's main() method is the applet sans gui.
 * The class MultiplexorExpander doesn't write a Log File
 * or count the number of elementary operations out. This one does.
 */
public class MultiplexorExpanderMain {
	private MultiplexorExpander	_expander;
	private int		_lenOfSEO;
	/**
	 *
	 */
	public MultiplexorExpanderMain(
			String 	filePrefixIn,
			String 	filePrefixOut,
			int numGitsIn,
			int compiMode,
			int bitPrecision)
	{
		
		_expander = new MultiplexorExpander(
				filePrefixIn,
				filePrefixOut,
				numGitsIn,
				compiMode,
				bitPrecision);
    	
    	SEO_countOnlyReader	reader = new SEO_countOnlyReader(
    	    filePrefixOut);
    	_lenOfSEO = reader.getLenOfSEO();
    	//System.out.println(reader);
    	
    	
    	PrintWriter   logOut = null;
    	try{
	        File  logFile = new File(filePrefixOut + "_log.txt");
	        logOut = new PrintWriter(logFile);
    	}
    	catch(FileNotFoundException ex){
    		System.out.println("\n" + ex.toString());
        }
    	logOut.println("Inputs:");
        logOut.println("Prefix for Input Files = " + filePrefixIn);
        logOut.println("Prefix for Output Files = " + filePrefixOut);
        logOut.println("Number of Grounded Bits In = " + numGitsIn);
        switch(compiMode){
	        case(MultiplexorExpander.EXACT_SEO):
	        	logOut.println("Compilation Mode = EXACT_SEO");
	        	break;	        
	        case(MultiplexorExpander.ORACULAR_APPROX):
	        	logOut.println("Compilation Mode = ORACULAR_APPROX");
	        	logOut.println("Bit Precision = " + bitPrecision);
	        	break;
	        default:
	        	Throw.If(true, "unlisted compilation mode");
        }
        logOut.println(filePrefixIn + "_eng.txt");
        logOut.println(filePrefixIn + "_pic.txt");
        
        logOut.println("");
        logOut.println("Outputs:");
        logOut.println("Number of Non-grounded Bits = " + 
        		_expander.getNumNonGits());
        logOut.println("Number of Grounded Bits Out = " + 
        		_expander.getNumGitsOut());
        logOut.println(filePrefixOut + "_eng.txt");
        logOut.println(filePrefixOut + "_pic.txt");
        logOut.println(filePrefixOut + "_log.txt");
        logOut.println("Number of Elem. Ops. Out= " + _lenOfSEO);
 //       logOut.printf("Error = %e\n", _error);
        logOut.close();
   	
	}	
	/**
	 *
	 */
	public MultiplexorExpander  getExpander() {
		return _expander;
	}
	/**
	 *
	 */
	public int getLenOfSEO() {
		return _lenOfSEO;
	}
	/**
	 *
	 */
    public static void main(String[] args){
    	
//	   String 	filePrefixIn = "one_in";
//	   String 	filePrefixOut = "one_out";
	   String 	filePrefixIn = "all_in";
	   String 	filePrefixOut = "all_out";
	   int numGitsIn = 0;
	   int compiMode = MultiplexorExpander.ORACULAR_APPROX;
	   //int compiMode = MultiplexorExpander.EXACT_SEO;
	   int bitPrecision = 3;
 	   
	   new MultiplexorExpanderMain(
			filePrefixIn,
			filePrefixOut,
			numGitsIn,
			compiMode,
			bitPrecision);
       
	   //can't call SEO_reader on in files.
	   //because SEO_reader doesn't know how to read MP_Y
    }
}
