/**
 * This class writes sequence of operations for 
 * Grover pi/3 Fixed Point Search.
 */
public abstract class GroverPiOver3Writer {
	public final static double PI_OVER3 = Math.PI/3;
	public final static Complex OMEGA = new Complex(Math.cos(PI_OVER3), Math.sin(PI_OVER3) );
		
	/**
	 *
	 */	
    public void write(int k)
    {
    	if(k==0){
    		//write nothing
    	}else{
	    	write(k-1);
	    	writeMat2();
	    	writeHermitian(k-1);
	    	writeMat1();
	    	write(k-1);
    	}
	}
    /**
	 *
	 */	
    public void writeHermitian(int k)
    {
    	if(k==0){
    		//write nothing
    	}else{       	
        	writeHermitian(k-1);
        	writeMat1Hermitian();
        	write(k-1);
        	writeMat2Hermitian();
        	writeHermitian(k-1);
    	}	
    }
	/**
	 *
	 */	
	public abstract void writeMat1();
	public abstract void writeMat1Hermitian();
	public abstract void writeMat2();
	public abstract void writeMat2Hermitian();

}
