/**
 * This class is a wrapper for an Array of Doubles.
 * It can be extended if you want the "array of doubles" to be
 * stored internally as an algorithmic function from the integers 
 * to the doubles, instead of a numeric array.
 */

public class DoubleArray{
	protected double [] 	_array = null;
	protected int 			_len;
	protected boolean 		_useNumeric = true;//default
	//Sometimes may have
	//both numeric and functional get()
	//This tells which one to use
	/**
	 * 
	 */	
	public DoubleArray(){
	}
	/**
	 * 
	 */	
	public DoubleArray(int len){
		reserveMemory(len);
	}
	/**
	 * 
	 */	
	public DoubleArray(double[] array){
		_array = array;
		_len = array.length;
	}
	/**
	 * 
	 */	
	public void reserveMemory(int len){
		_array = new double[len];
		_len = _array.length;
	}
	/**
	 * 
	 */
	public void set(int j, double x){
		Throw.If(_array==null, "DoubleArray has null _array");
		_array[j] = x;
	}
	/**
	 * 
	 */
	public double get(int j){//override this if want function:int->double
		Throw.If(_array==null, "DoubleArray has null _array");
		return _array[j];
	}
	/**
	 * 
	 */	
	public int length(){
		return _len;
	}
	/**
	 * 
	 */
	public void setUseNumeric(boolean useNumeric){
		_useNumeric = useNumeric;
	}
	/**
	 * 
	 */
	public boolean usingNumeric(){
		return _useNumeric;
	}

}
