/**
 * This class provides abstract methods
 * for energy and neighborhood functions of a
 * minimization problem
 */	
public abstract class  MinimizationProblem{
	protected int _numStates;
	protected double _upBdNeig;//upper bound for max_y sum_x neighbors(y,x)
	/**
	 * 
	 */
	public MinimizationProblem(
		int numStates,
		double upBdNeig)
	{
		_numStates = numStates;
		_upBdNeig = upBdNeig;
		int row, col, rowNeighbors;
		for(row=0; row<_numStates; row++){
			rowNeighbors=0;
			for(col=0; col<_numStates; col++){
				if(areNeighbors(row,col)){rowNeighbors++;}
				Throw.If(areNeighbors(row,col)!=areNeighbors(row,col), 
						"neighbors function is not symmetric");
			}
			Throw.If(rowNeighbors>_upBdNeig, "Upper bound on number of neighbors is too small");
		}
		
	}
	
	/**
	 * 
	 */
	public int getNumStates(){
		return _numStates;
	}
	/**
	 * 
	 */
	public double getUpBdNeig(){
		return _upBdNeig;
	}
	/**
	 * 
	 */
	public abstract double energy(int x);
	/**
	 * 
	 */
	public abstract boolean areNeighbors(int x, int y);
	
}
