/**
 * This class creates a 2 dimensional matrix
 * exp(i angle)*diag(1,1)
 * Entries of this matrix can be accessed via getEntry(row, col)
 */
public class OneBitPhaseFactor extends OneBitGate{
    private double _radAngle; //internal angle in radians
    private Complex _phaseFactor;
    
	/**
	 *
	 */
    public OneBitPhaseFactor(double angle) {
        _radAngle = angle;
        _phaseFactor = new Complex(Math.cos(angle), Math.sin(angle));
        _entries[0][0] = _phaseFactor;
        _entries[0][1] = Globals.COMPLEX0;
        _entries[1][0] = Globals.COMPLEX0;
        _entries[1][1] = _phaseFactor;       
    }
	/**
	 *
	 */
    public double getAngle(){
        return _radAngle;
    }
	/**
	 *
	 */
    public Complex getPhaseFactor(){
        return _phaseFactor;
    }

	/**
	 *
	 */
    public static void main(String[] args){
        System.out.print(((OneBitGate)(
        	new OneBitPhaseFactor(Math.PI))).toString());
        
    }

    
}
