import java.io.*;
import java.util.Scanner;

/**
 * A SEO is a Sequence of Elementary Operations.
 * This class reads a SEO from an English file.
 * It doesn't multiply the elementary operations like SEO_reader does.
 * It merely calculates the SEO length, taking into account
 * nested loops.
 */
 
public class SEO_countOnlyReader {

    private String      _filePrefix;
    private Scanner   	_englishIn;
    private LineList 	_lineList;
    private int _lenOfSEO;
 

	/**
	 *
	 */
    public SEO_countOnlyReader(
        String filePrefix) 
	{
		_filePrefix = filePrefix;
		try{
			File  file = new File(filePrefix + "_eng.txt");
			_englishIn = new Scanner(file);
			_lineList = new LineList();
			_lenOfSEO = 0;
						
			String lineName = "";
			while(_englishIn.hasNext()){
				lineName = _englishIn.next();
				if(lineName.equals("LOOP")){
					readLOOP();
				}else if(lineName.equals("NEXT")){
					readNEXT();
				}else{
					readAnyGate();                
				}
			}
		}
		catch(FileNotFoundException ex){
			System.out.println("\n" + ex.toString());
		}
		 
 
		int lineListLen = _lineList.size();
		int currentLine = 0;
		while(currentLine < lineListLen){
			Line l = _lineList.get(currentLine);
			switch(l._lineType){
				case 	LOOP:
					//increment timesVisited
					l._ints[1]++;
					break;
				case 	NEXT:
					int loopNum = l._ints[0];
					if(_lineList.get(loopNum)._ints[0]/*reps*/
					      != 
					   _lineList.get(loopNum)._ints[1]/*timesVisited*/
					){
						currentLine = loopNum;
						//increment timesVisited
						_lineList.get(loopNum)._ints[1]++;
					}else{
						//set timesVisited to zero
						_lineList.get(loopNum)._ints[1] = 0;
					}
					break;
				default: 	
					_lenOfSEO++;
			}//end cases
			currentLine++;
		}//end while
    }
	/**
	 *
	 */    
    protected void finalize() throws java.lang.Throwable{
        if(_englishIn != null){
            _englishIn.close();
        }
        super.finalize();
    }
	/**
	 * 
	 */
    private void readLOOP(){
    	int lineNum = _englishIn.nextInt();
    	_englishIn.next();//skip "REPS:"
    	int reps = _englishIn.nextInt();
 		_lineList.addLOOP(lineNum, reps);
    }
	/**
	 * 
	 */
    private void readNEXT(){
    	int loopNum = _englishIn.nextInt();
 		_lineList.addNEXT(loopNum);
    }

	/**
	 * 
	 */
    private void readAnyGate(){
    	_englishIn.nextLine();
    	_lineList.addDummyGate();
    }
	/**
	 *
	 */
	public int getLenOfSEO() {
		return _lenOfSEO;
	}
}
