
/**
 * A SEO is a Sequence of Elementary Operations.
 * This class reads a SEO from an English file.
 * It pre-multiplies _matrix by 
 * each elementary operation it reads. 
 * _matrix is initially the unit matrix.
 * The "Mu" in readerMu stands for multiplier
 */
 
public class SEO_readerMu extends SEO_reader{

    private boolean     _useSparse;
    private UnitaryMat  _matrix;
    private int 		_lenOfSEO;
 

	/**
	 *
	 */
    public SEO_readerMu(
        String filePrefix, 
        int numBits, 
        boolean useSparse) 
	{
		super(filePrefix, numBits);
		_useSparse = useSparse;

		readStoreAll();		 
    	//constructor sets _matrix to identity
		_matrix = new UnitaryMat(_numBits, _useSparse);
		_lenOfSEO = _lineList.multiplyYourself(_matrix);
		closeFile();
	}
   
	/**
	 *
	 */
    public Complex getEntry(int row, int col) {
    	return _matrix.getEntry(row, col);
    }
	/**
	 *
	 */
	public int getLenOfSEO() {
		return _lenOfSEO;
	}
	/**
	 *
	 */
    public String toString(){
    	
    	return _matrix.toString();
    	
    }
	/**
	 * 
	 */ 
    public static void main(String[] args){
    	
    	String	filePrefix = "reader";
    	int numBits = 4;
    		   
    	SEO_readerMu	reader = new SEO_readerMu(
    	    filePrefix,
    	    numBits, 
    	    false); // useSparse
    	System.out.println(reader);
    	System.out.println("Number of Elem. Ops. = " + reader.getLenOfSEO());
    }
}
