/**
 * This class stores a list of TFcontrols (TF=TrueFalse)
 * where F=P0=nbar and T=P1=n
 */
public class TFControls extends Controls<Boolean>{
	
/**
 * 
 */	
	public TFControls(){
		super();
	}
/**
 * 
 */	
	public TFControls(int numBits, int numControls){
		super(numBits, numControls);
		_types  = new  Boolean[numControls];
	}
/**
 * 
 */	
	public TFControls(TFControls controls, int extraNumBits){
		super(controls, extraNumBits);
		_types = new Boolean[_numControls];
		for(int j=0; j<_numControls; j++){
			_types[j] = controls._types[j];
		}
	}


/**
 * 
 */
	public TFControls refreshedControls(CktEmbedder  emb){
		TFControls  aftControls = new TFControls();
		if(emb.isIdentity()){
			aftControls   =  this;
		}else{			
			Throw.If(_numBits != emb.getNumBitsBef(),
				"controls cannot be reset with CktEmbedder");
			
//			int numBitsBef = _numBits;
			int numBitsAft = emb.getNumBitsAft();
			
			int newNumControls = _numControls + emb.getNumNewControls();
			int[] newBitPositions = new int[newNumControls];
			Boolean[] newTypes = new Boolean[newNumControls];
			
			boolean[] isP0Control = Globals.F_vec(numBitsAft);
			boolean[] isP1Control = Globals.F_vec(numBitsAft);
			

			for(int aft=0; aft < numBitsAft; aft++){
				if(emb.isNewBit(aft)){
					isP0Control[aft] = emb.isP0Control(aft);
					isP1Control[aft] = emb.isP1Control(aft);
				}
			}
			for(int j=0; j < _numControls; j++){
				if(_types[j]==false){
					isP0Control[emb.aft(_bitPositions[j])] = true;			
				}else{//_types[j]==true
					isP1Control[emb.aft(_bitPositions[j])] = true;	
				}			
			}
			
			//numBitsAft > 0 because numBitsAft>=numBitsBef>0
			int c = 0;
			for(int aft = numBitsAft-1; aft>=0; aft--){;
				if(isP0Control[aft] || isP1Control[aft]){					
					newBitPositions[c] = aft;
					newTypes[c] = isP1Control[aft]==true?true:false;
					c++;		
				}
			}
			
			aftControls._numBits = numBitsAft;
			aftControls._numControls = newNumControls;
			aftControls._bitPositions = newBitPositions;
			aftControls._types = newTypes;
		}
		return  aftControls;
	}

}
