import java.io.*;

/**
 * This class's main() method is the applet sans gui.
 * QOperAv= Quantum Operator Average
 */
public class QOperAvMain {
	
	private int		_lenOfSEO;
//	private double 	_error;

	/**
	 *
	 */
	public QOperAvMain(
			String  filePrefix,
			int numAtomBits,
			int numProbeBits,
			double gamma,
			double dtOver2pi)
	{
		String filePrefixPlus = filePrefix + "_qoa";
			
		QOperAvSEO_writer1  wr =new QOperAvSEO_writer1(
			filePrefixPlus,
	        numAtomBits,
	        numProbeBits,
	        gamma,
	        dtOver2pi);
    	
    	SEO_countOnlyReader	reader = new SEO_countOnlyReader(
    			filePrefixPlus);
    	_lenOfSEO = reader.getLenOfSEO();
    	//System.out.println(reader);
    	
    	
    	PrintWriter   logOut = null;
    	try{
	        File  logFile = new File(filePrefixPlus + "_log.txt");
	        logOut = new PrintWriter(logFile);
    	}
    	catch(FileNotFoundException ex){
            ex.printStackTrace();
        }
    	logOut.println("Inputs:");
        logOut.println("File Prefix = " + filePrefix);
        logOut.println("Number of Atom Qubits = " + numAtomBits);
        logOut.println("Number Of Probe Qubits = " + numProbeBits);
        logOut.println("gamma = " + gamma);
        logOut.println("Delta t/(2*PI) = " + dtOver2pi);
        
        logOut.println("");
        logOut.println("Outputs:");
        logOut.println("Number of Qubits = " + wr.getNumBits());
        logOut.println("Number of Elem. Ops. = " + _lenOfSEO);
 //       logOut.printf("Error = %e\n", _error);
        logOut.close();
   	
	}
	
	/**
	 *
	 */
	public int getLenOfSEO() {
		return _lenOfSEO;
	}
	/**
	 *
	 */
//	public double getError(){
//		return _error;
//	}
	/**
	 *
	 */
    public static void main(String[] args){
    	
		String  filePrefix = "test";
		int numAtomBits = 3;
		int numProbeBits = 4;
		double gamma = 1.0;
		double dtOver2pi = 1.0;		
			
		new QOperAvMain(
    			filePrefix,
    			numAtomBits,
    			numProbeBits,
    			gamma,
    			dtOver2pi);
 
    }
}
