import java.io.PrintWriter;


/**
 * This class extends the abstract class PhaseEstSEO_writer.
 * It writes into the English and Picture Files
 * the phase estimation step of the QOperAv algorithm.
 * Atom is exp(iA \Delta t) in my paper
 */

public class QOperAvPhaseEstSEO_writer1 extends PhaseEstSEO_writer{

	/**
	 *
	 */
	public QOperAvPhaseEstSEO_writer1(
	    String 	filePrefix,
	    int numBits,
		int numProbeBits)
	{
		super(filePrefix, numBits, numProbeBits, PhaseEstEnding.QFT);
	}
	/**
	 * 
	 */
    public QOperAvPhaseEstSEO_writer1(
		PrintWriter  englishOut,
		PrintWriter  pictureOut,
		boolean doWrite,
		CktEmbedder emb,
		int numProbeBits)
    {
    	super(englishOut, pictureOut, doWrite, 
    			emb, numProbeBits, PhaseEstEnding.QFT);
    }
	/**
	 * an override!
	 */	 
    public void  writeAtomPow(int powerOf2){
    	//The contents of this method are only a
    	//dumb example for demonstration purposes.
    	//Repeating N = 2^powerOf2 times
    	//the circuit for atom=exp(iA\Delta t)
    	//is very dumb way to
    	//raise atom to the Nth power.
    	//In real life, you want to write here a circuit
    	//for exp(iN A\Delta t) if you know it.

		int loopNum = getLineCount();
		writeLOOP(loopNum, 1<<powerOf2);
		
		new FouSEO_writer(
				_englishOut,
				_pictureOut,
				false,// doWrite
				_emb).write();

		writeNEXT(loopNum);
	}
    /**
	 * an override! 
	 */	 
    public void  writeAtomPowHermitian(int powerOf2){
    	//The contents of this method are only a
    	//dumb example for demonstration purposes.
		int loopNum = getLineCount();
		writeLOOP(loopNum, 1<<powerOf2);
		
		new FouSEO_writer(
				_englishOut,
				_pictureOut,
				false,// doWrite
				_emb).writeHermitian();

		writeNEXT(loopNum);
	}

	/**
	 * 
	 */	
	 public void  writeAtom(){
		Throw.If(true, "not using this method");
	}
	/**
	 * 
	 */	
	 public void  writeAtomHermitian(){
		Throw.If(true, "not using this method");
	}
	/**
	 * 
	 */	
	public static void main(String[] args){
		new QOperAvPhaseEstSEO_writer1(
		        "testPE",
		        7,// numBits
				4);// numProbeBits
		
	}

}
