/**
 * This class extends abstract class QOperAvSEO_writer
 */

public class QOperAvSEO_writer1 extends QOperAvSEO_writer{
	
	
	/**
	 * 
	 */	
	public QOperAvSEO_writer1(
		String 	filePrefix,
		int 	numAtomBits,
	    int 	numProbeBits,
	    double 	gamma,
	    double 	dtOver2pi)	
	{
		 super(filePrefix, numAtomBits, numProbeBits, gamma, dtOver2pi);
	}
	/**
	 * 
	 */	
	 public void  writeAtomicV()
	 {
		 //AtomicV is the unitary matrix V in my paper
		new FouSEO_writer(
				_englishOut,
				_pictureOut,
				false,// doWrite
				_emb).write();
	}
	 /**
	 * 
	 */	
	 public void  writePhaseEstimator()
	 {
		 //this calls extension of abstract class PhaseEstSEO_writer
		 //where Atom is exp(iA \Delta t) in my paper
		 new QOperAvPhaseEstSEO_writer1(
			_englishOut,
	        _pictureOut,
	        true,//doWrite
	        _emb,
			_numProbeBits);	 
	 }
	 
	 /**
	 * 
	 */
	public double positiveFun(double x)
	{	
		//this is the function f() in my paper
		//output must positive
		return Math.exp(-.1*x);
		
		//return x;
		
	}

	/**
	 * 
	 */
	public static void main(String[] args) {
		double gamma = 1.0;
		double dtOver2pi = 1.0;
		new QOperAvSEO_writer1(
		        "testAll",
		        3,// numAtomBits
				4,// numProbeBits
				gamma,
				dtOver2pi);
	}

}
