import java.io.*;

/**
 * This class's main() method is the applet sans gui.
 * SimAnn = Simulated Annealing
 */
public class SimAnnMain {
	
	private int		_lenOfSEO;
//	private double 	_error;

	/**
	 *
	 */
	public SimAnnMain(
			String  filePrefix,
			int numStateBits,
			int numProbeBits,
			int numPESteps,
			int groverDepth,
			double upBdNeig,
			int     numBetas,
			double  deltaBeta)
	{
		String filePrefixPlus = filePrefix + "_sann";
		double[] betas = new double[numBetas];
		for(int j=0; j<numBetas; j++){
			betas[j] = j*deltaBeta;
		}
			
		SimAnnSEO_writer wr =new SimAnnSEO_writer(
			filePrefixPlus,
	        numStateBits,
	        numProbeBits,
	        numPESteps,
	        groverDepth,
	        new SimAnnMinProblem(1<<numStateBits, upBdNeig),
	        betas);
    	
    	SEO_countOnlyReader	reader = new SEO_countOnlyReader(
    			filePrefixPlus);
    	_lenOfSEO = reader.getLenOfSEO();
    	//System.out.println(reader);
    	
    	
    	PrintWriter   logOut = null;
    	try{
	        File  logFile = new File(filePrefixPlus + "_log.txt");
	        logOut = new PrintWriter(logFile);
    	}
    	catch(FileNotFoundException ex){
            ex.printStackTrace();
        }
    	logOut.println("Inputs:");
        logOut.println("File Prefix = " + filePrefix);
        logOut.println("Number of State Bits = " + numStateBits);
        logOut.println("Number Of Probe Bits (for each PE step) = " + numProbeBits);
        logOut.println("Number Of Phase Estimation (PE) Steps = " + numPESteps);
        logOut.println("Grover Depth = " + groverDepth);
        logOut.println("Upper Bound on Number of Neighbors = " + upBdNeig);
        logOut.println("Number of Betas = " + numBetas);
        logOut.println("Delta Beta Per Unit Time = " + deltaBeta);
        
        logOut.println("");
        logOut.println("Outputs:");
        logOut.println("Number of Qubits = " + wr.getNumBits());
        logOut.println("Number of Elem. Ops. = " + _lenOfSEO);
 //       logOut.printf("Error = %e\n", _error);
        logOut.close();
   	
	}
	
	/**
	 *
	 */
	public int getLenOfSEO() {
		return _lenOfSEO;
	}
	/**
	 *
	 */
//	public double getError(){
//		return _error;
//	}
	/**
	 *
	 */
    public static void main(String[] args){
    	
		String  filePrefix = "test";
		int numStateBits = 1;
		int numProbeBits = 3;
		int numPESteps = 3;
		int groverDepth = 2;
		double upBdNeig = 3;		
		
		double deltaBeta = 1;
		int numBetas = 3;
			
		new SimAnnMain(
    			filePrefix,
    			numStateBits,
    			numProbeBits,
    			numPESteps,
    			groverDepth,
    			upBdNeig,	
    			numBetas,
    			deltaBeta);
 
    }
}
