/**
 * This class specifies the simple minimization problem
 * considered by the applet QuSAnn
 */
public class SimAnnMinProblem extends MinimizationProblem{
	public SimAnnMinProblem(
			int numStates,
			double upBdNeig)
	{
		super(numStates, upBdNeig);
	}
	/**
	 * 
	 */
	public double energy(int x){
		return Math.pow(x-_numStates/2, 2);
	}
	/**
	 * 
	 */
	public boolean areNeighbors(int x, int y){
		boolean areN = false;
		if(x!=y && Math.abs(x-y)<=1){areN=true;}
		return areN;
		
	}
	
	/**
	 * 
	 */
	public static void main(String[] args)
	{
		String  filePrefix = "problem";
		int numStateBits = 1;
		int numAtomBits = 2*numStateBits;
		int numProbeBits = 3;
		int numPESteps = 3;
		int numBits = numAtomBits + numProbeBits*numPESteps;
		int groverDepth = 2;
		double upBdNeig = 3;		
		
		double[] betas = new double[3];
		betas[0] = 1;
		betas[1] = 2;
		betas[2] = 4;
		

		new SimAnnSEO_writer(
	        filePrefix,
	        numBits,
	        numProbeBits,
	        numPESteps,
	        groverDepth,
	        new SimAnnMinProblem(1<<numStateBits, upBdNeig),
	        betas);
	}


}
