import java.awt.*;
import java.awt.event.*;

import javax.swing.*;
import javax.swing.border.TitledBorder;

/**
 * This class defines the GUI for the main and 
 * only window (Control Panel) of QuanFruit.
 */
public class FruitApplet extends JApplet{
	private JLabel 		_L_image;
	private JTextField	_TF_filePrefix;
	private JComboBox 	_CB_lineNumBits;
	private JComboBox 	_CB_treeNumBits;
	private JTextField	_TF_strength;
	private JTextField	_TF_lineDoor;
	private JTextField	_TF_oracleBands;
	private JComboBox 	_CB_lineNumTrots;
	private JComboBox 	_CB_lineOrderApprox;
	private JComboBox 	_CB_treeNumTrots;
	private JComboBox 	_CB_metaNumTrots;
	private JComboBox 	_CB_metaOrderApprox;
	private JButton		_B_computeSEO;
	private JTextField	_TF_numBits;
	private JTextField	_TF_lenOfSEO;
	private JTextField	_TF_error;
	/**
	 * 
	 */
	public void init(){
		java.net.URL iconURL = getClass().getResource("qfru-logo.gif");
		_L_image = new JLabel(new ImageIcon(iconURL));
		_TF_filePrefix = new JTextField();
		_CB_lineNumBits = new JComboBox(new String[]
		    {"2", "3", "4", "5", "6", "7", "8"});
		_CB_treeNumBits = new JComboBox(new String[]
		    {"2", "3", "4", "5", "6", "7", "8"});
		_TF_strength = new JTextField();
		_TF_lineDoor = new JTextField();
		_TF_oracleBands = new JTextField();
		_CB_lineNumTrots = new JComboBox(new String[]
            {"1", "2", "3", "4", "5"});
        _CB_lineOrderApprox = new JComboBox(new String[]
            {"2", "4", "6", "8"});
		_CB_treeNumTrots = new JComboBox(new String[]
		    {"1", "2", "3", "4", "5"});
		_CB_metaNumTrots = new JComboBox(new String[]
		    {"1", "2", "3", "4", "5"});
		_CB_metaOrderApprox = new JComboBox(new String[]
		    {"2", "4", "6", "8"});		                                        
		_B_computeSEO = new JButton("Write Files");
		_TF_numBits = new JTextField();
		_TF_numBits.setEditable(false);
		_TF_lenOfSEO = new JTextField();
		_TF_lenOfSEO.setEditable(false);
		_TF_error = new JTextField();
		_TF_error.setEditable(false);
		
		
		JPanel panHeader = new JPanel(new BorderLayout(2, 2));//hgap, vgap
		panHeader.add(_L_image, BorderLayout.CENTER);
		panHeader.add(new JLabel(Globals.VERSION), BorderLayout.SOUTH);
		
		JPanel panIn = new JPanel(new GridLayout(12, 2));//rows, cols
		panIn.add(new JLabel("File Prefix"));
			panIn.add(_TF_filePrefix);
		panIn.add(new JLabel("Line: Number of Qubits"));
			panIn.add(_CB_lineNumBits);
		panIn.add(new JLabel("Tree: Number of Qubits"));
			panIn.add(_CB_treeNumBits);
		panIn.add(new JLabel("Coupling Constant"));
			panIn.add(_TF_strength);
		panIn.add(new JLabel("Line Door"));
			panIn.add(_TF_lineDoor);
		panIn.add(new JLabel("Bands"));
			panIn.add(_TF_oracleBands);
		panIn.add(new JLabel("Line: Number of Trots"));
			panIn.add(_CB_lineNumTrots);
		panIn.add(new JLabel("Line: Order of Approx."));
			panIn.add(_CB_lineOrderApprox);
		panIn.add(new JLabel("Tree: Number of Trots"));
			panIn.add(_CB_treeNumTrots);
		panIn.add(new JLabel("Tree: Order of Approx."));
			panIn.add(new JLabel("3"));
		panIn.add(new JLabel("Meta: Number of Trots"));
			panIn.add(_CB_metaNumTrots);
		panIn.add(new JLabel("Meta: Order of Approx."));
			panIn.add(_CB_metaOrderApprox);

		panIn.setBorder(new TitledBorder("Inputs"));
		
		JPanel panWriteFlow = new JPanel(new FlowLayout(FlowLayout.RIGHT));
		panWriteFlow.add(_B_computeSEO);

		JPanel panInPlus = new JPanel(new BorderLayout(2, 2));//hgap, vgap
		panInPlus.add(panHeader, BorderLayout.NORTH);
		panInPlus.add(panIn, BorderLayout.CENTER);
		panInPlus.add(panWriteFlow, BorderLayout.SOUTH);
		
		JPanel panOut = new JPanel(new GridLayout(3, 2));//rows, cols
		panOut.add(new JLabel("Number of Qubits"));
			panOut.add(_TF_numBits);
		panOut.add(new JLabel("Number of Elem. Ops."));
			panOut.add(_TF_lenOfSEO);
		panOut.add(new JLabel("Error"));
			panOut.add(_TF_error);
		panOut.setBorder(new TitledBorder("Outputs"));
		
		setLayout(new BorderLayout(2, 2));//hgap, vgap
		add(panInPlus, BorderLayout.CENTER);
		add(panOut, BorderLayout.SOUTH);
		
		_B_computeSEO.addActionListener(new ButtonListener());
	}
	
	/**
	 *
	 */
	private class ButtonListener implements ActionListener{

		public void actionPerformed(ActionEvent eve) {

	        String 	filePrefix;
	        int lineNumBits;
	        int treeNumBits;
	        double strength;
	        int lineDoor;
			OracleBands bands;
			int  lineNumTrots;
			int  lineSuzukiHalfOrder;			
			int  treeNumTrots;
			int  metaNumTrots;
			int  metaSuzukiHalfOrder;
			
			try{
				if(	_TF_filePrefix.getText().length()==0 ||
					_TF_strength.getText().length()==0 ||
					_TF_lineDoor.getText().length()==0 ||
					_TF_oracleBands.getText().length()==0)
				{ throw new Exception();}
				
				filePrefix = _TF_filePrefix.getText();
				
				lineNumBits = _CB_lineNumBits.getSelectedIndex() + 2;
				
				treeNumBits = _CB_treeNumBits.getSelectedIndex() + 2;
				
				strength = Double.parseDouble(_TF_strength.getText());
				
				lineDoor =  Integer.parseInt(_TF_lineDoor.getText());				

				
				String[] s = _TF_oracleBands.getText().split("\\D");
				int numBands = s.length;
				if(numBands%2==1){
					throw new Exception();
				}else{
					numBands = numBands/2;
				}
				int[][] mat = new int[numBands][2];
				int counter = 0;
				for(int j=0; j < s.length; j++){
					mat[counter/2][counter%2] = 
						Integer.parseInt(s[j]);
					counter++;
				}		
				bands = new OracleBands(treeNumBits-1, mat);

				
				lineNumTrots = _CB_lineNumTrots.getSelectedIndex() + 1;
				lineSuzukiHalfOrder = _CB_lineOrderApprox.getSelectedIndex() + 1;

				treeNumTrots = _CB_treeNumTrots.getSelectedIndex() + 1;

				metaNumTrots = _CB_metaNumTrots.getSelectedIndex() + 1;
				metaSuzukiHalfOrder = _CB_metaOrderApprox.getSelectedIndex() + 1;

				FruitMain 	m = new FruitMain(
		    	        filePrefix,
		    	        lineNumBits,
		    	        treeNumBits,
		    	        strength,
		    	        lineDoor,
		    			bands,
		    			lineNumTrots,
		    			lineSuzukiHalfOrder,			
		    			treeNumTrots,
		    			metaNumTrots,
		    			metaSuzukiHalfOrder);
				_TF_numBits.setText(String.format("%d", m.getNumBits()));
				_TF_lenOfSEO.setText(String.format("%d", m.getLenOfSEO()));
				_TF_error.setText(String.format("%e", m.getError()));
			}
			catch(Exception ex){
				_TF_numBits.setText("");
				_TF_lenOfSEO.setText("");
				_TF_error.setText("");
				JOptionPane.showMessageDialog(null, 
						"QuanFruit got BAD INPUT:\n" + ex.toString());
				return;
			}
			
			

		}
	
	}
	/**
	 *
	 */
	public static void main(String[] args) {
	    
	    JFrame frame = new JFrame("QuanFruit");

	    
	    FruitApplet applet = new FruitApplet();

	    frame.add(applet, BorderLayout.CENTER);

	    applet.init();

	    //frame.setLocationRelativeTo(null); // Center the frame
	    frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);	    
	    frame.pack();//frame.setSize(400, 250);
	    frame.setVisible(true);
	  }


}

