import java.io.*;

/**
 * This class's main() method is the applet sans gui.
 * Shi = Shift
 */
public class ShiftMain {
	private int		_lenOfSEO;
	private double 	_error;

	/**
	 *
	 */
	public ShiftMain(
	        String 	filePrefix, 
	        int numBits,  
	        int shift)
	{
		String filePrefixPlus = filePrefix + "_qshi";

        
		int numRows = 1<<numBits;
		
    	new ShiftSEO_writer(
    		filePrefix,
            numBits, 
        	shift);

    	
    	ShiftUinMat   Uin = new ShiftUinMat(numBits, shift);
    	
    	SEO_readerMu	reader = new SEO_readerMu(
    	    filePrefixPlus,
    	    numBits, 
    	    false); // useSparse
    	_lenOfSEO = reader.getLenOfSEO();
    	//System.out.println(reader);
    	
    	_error = 0.0;
    	int row, col;
    	for(row=0; row<numRows; row++){
    		for(col=0; col<numRows; col++){
    			_error += Complex.abs(Complex.minus(
    					Uin.getEntry(row,col), 
    					reader.getEntry(row,col)
    					));
    		}
    	}
    	
    	PrintWriter   logOut = null;
    	try{
	        File  logFile = new File(filePrefixPlus + "_log.txt");
	        logOut = new PrintWriter(logFile);
    	}
    	catch(FileNotFoundException ex){
    		System.out.println("\n" + ex.toString());
        }
    	logOut.println("Inputs:");
        logOut.println("File Prefix = " + filePrefix);
        logOut.println("Number of Bits = " + numBits);
        logOut.println("Shift = " + shift);

        logOut.println("");
        logOut.println("Outputs:");
        logOut.println("Number of Elem. Ops. = " + _lenOfSEO);
        logOut.printf("Error = %e\n", _error);
        logOut.close();
   	
	}
	/**
	 *
	 */
	public int getLenOfSEO() {
		return _lenOfSEO;
	}
	/**
	 *
	 */
	public double getError(){
		return _error;
	}
	/**
	 *
	 */
    public static void main(String[] args){
    	
		int numBits = 4;
    	int shift = 5;//1/Math.sqrt(2);
	  	String 	filePrefix = "test";
    	
    	ShiftMain  m  = new ShiftMain(
    			filePrefix, numBits, shift);
    	
    	
/*    	
    	System.out.println("expiMat");
    	System.out.println(expiMat.toString());

    	System.out.println("SEO product");
    	System.out.println(reader);
*/
    	System.out.println("error is  " + m._error);
   	

    }
}
