import java.io.PrintWriter;


/**
 * This class writes into the English and Picture files
 * a SINGLE phase estimation step
 * of the Quibbs algorithm.
 */
public class QuibbsPhaseEstSEO_writer extends PhaseEstSEO_writer{
	private CB_NetQEmb   _probQEmb;
	/**
	 *
	 */
	public QuibbsPhaseEstSEO_writer(
	    String 	filePrefix,
	    int numBits,
		int numProbeBits,
		CB_NetQEmb  probQEmb)
	{
		super(filePrefix, numBits);
		_numAtomBits = _numBits - numProbeBits;
		_numProbeBits = numProbeBits;
		_ending = PhaseEstEnding.HADS;
		_probQEmb = probQEmb;
		
	    write();
	    
	    closeFiles();       
	}
	/**
	 * 
	 */
    public QuibbsPhaseEstSEO_writer(
		PrintWriter  englishOut,
		PrintWriter  pictureOut,
		boolean doWrite,
		CktEmbedder emb,
		int numProbeBits,
		CB_NetQEmb  probQEmb)
    {
    	super(englishOut, pictureOut, emb);

		_numAtomBits = _numBits - numProbeBits;
		_numProbeBits = numProbeBits;
		_ending = PhaseEstEnding.HADS;
		_probQEmb = probQEmb;
 	
    	
    	if(doWrite){write();}
    }
	/**
	 * 
	 */	 
    public void  writeAtom(){
		new CB_NetSzegedySEO_writer(
			_englishOut,
			_pictureOut,
			false,// doWrite
			_emb,
	   	    _probQEmb
	        ).write();
	}
    /**
	 * 
	 */	 
    public void  writeAtomHermitian(){
		new CB_NetSzegedySEO_writer(
			_englishOut,
			_pictureOut,
			false,// doWrite
			_emb,
	   	    _probQEmb
	        ).writeHermitian();
	}
    /**
	 * 
	 */
	public static void main(String[] args){
		String filePrefix = "pEst";
		
		String 	relPath = "2nodes/";
		//String 	relPath = "3nodes/";
		//String 	relPath = "4nodeFullyConnected/";
		//String 	relPath = "Asia/";
		
		String 	statesFileName = "states.txt";
		String 	parentsFileName = "parents.txt";
		
		CB_Net  net = new CB_Net(relPath + statesFileName, 
						relPath + parentsFileName,
						relPath + "probs.txt");	
		int numStateBits = net.getNumNits();
		int numAtomBits = 2*numStateBits;
		int numProbeBits = 3;
		int numBits = numAtomBits + numProbeBits;
		QuibbsPhaseEstSEO_writer w =new QuibbsPhaseEstSEO_writer(
	        openEngFile(relPath + filePrefix),
	        openPicFile(relPath + filePrefix),
	        true,//doWrite
	        new CktEmbedder(numBits),//emb
			numProbeBits,
			new CB_NetQEmb(net, true/*usingEffiMeth*/));
		w.writeHermitian();
		w.closeFiles();

	}

}


