import java.io.PrintWriter;


/**
 * This class writes into the English and Picture files
 * MULTIPLE phase estimation steps (bunch of steps = stairs) 
 * of the Quibbs algorithm.
 */
public class QuibbsStairsSEO_writer extends PhaseEstStairsSEO_writer{
	/**
	 *
	 */
	public QuibbsStairsSEO_writer(
	    String 	filePrefix,
	    int numBits,
		int numProbeBits,
		CB_NetQEmb  probQEmb,
		int numPESteps)
	{
		super(	filePrefix,
				numBits,
				numProbeBits,
				(CB_NetQEmb) probQEmb,
				numPESteps);
 
	}
	/**
	 * 
	 */
    public QuibbsStairsSEO_writer(
		PrintWriter  englishOut,
		PrintWriter  pictureOut,
		boolean doWrite,
		CktEmbedder emb,
		int numProbeBits,
		CB_NetQEmb  probQEmb,
		int numPESteps)
    {
    	super(	englishOut,
    			pictureOut,
    			doWrite,
    			emb,
    			numProbeBits,
    			(CB_NetQEmb) probQEmb,
    			numPESteps);

    }
	/**
	 * 
	 */
	protected void writePhaseEst(CktEmbedder emb){
		new QuibbsPhaseEstSEO_writer(
			_englishOut,
	        _pictureOut,
	        false,//doWrite
	        emb.getCompositeMapOfYouFollowedBy(_emb),
			_numProbeBits,
			(CB_NetQEmb)_probQEmb).write();
	}
	/**
	 * 
	 */
	protected void writePhaseEstHermitian(CktEmbedder emb){
		new QuibbsPhaseEstSEO_writer(
			_englishOut,
	        _pictureOut,
	        false,//doWrite
	        emb.getCompositeMapOfYouFollowedBy(_emb),
			_numProbeBits,
			(CB_NetQEmb)_probQEmb).writeHermitian();
	}
    /**
	 * 
	 */
	public static void main(String[] args){
		String  filePrefix = "stairs";

		String 	relPath = "2nodes/";
		//String 	relPath = "3nodes/";
		//String 	relPath = "4nodeFullyConnected/";
		//String 	relPath = "Asia/";
		
		String 	statesFileName = "states.txt";
		String 	parentsFileName = "parents.txt";
		
		CB_Net  net = new CB_Net(relPath + statesFileName, 
						relPath + parentsFileName,
						relPath + "probs.txt");	
		int numStateBits = net.getNumNits();
		int numAtomBits = 2*numStateBits;
		int numProbeBits = 3;
		int numPESteps = 3;
		int numBits = numAtomBits + numProbeBits*numPESteps;
		QuibbsStairsSEO_writer w = new QuibbsStairsSEO_writer(
	        openEngFile(relPath + filePrefix),
	        openPicFile(relPath + filePrefix),
	        true,//doWrite
	        new CktEmbedder(numBits),//emb
			numProbeBits,
			new CB_NetQEmb(net, true/*usingEffiMeth*/),
			numPESteps);
		w.writeHermitian();
		w.closeFiles();

	}

}


