/**
 * This class is a wrapper for the functions h(b|S) of the paper
 * ``Quantum Circuit for Discovering from Data the
 * Structure of Classical Bayesian Networks" by R.R. Tucci, arXiv:?
 */
public class Jen_hFun {
	int _numNodes;
	/**
	 * 
	 */		
	public Jen_hFun(int numNodes){
		_numNodes = numNodes;
		Throw.If(numNodes<1, "must have at least one node");
	}
	/**
	 * 
	 */		
	public int getNonCanonicalName(int node, int canName){
		Throw.If(canName<0 || canName>=_numNodes-1,
				"h function combination element is not expected");
		int val = canName;
		if(canName==node){
			val=_numNodes-1;
		}
		return val;
	}
	/**
	* This is just a trivial example.
	* Should replace this method's code with code
	* that applies to situation being considered.
	 */		
	public double h(int node, int[] comb){
		double val;
		if(comb!=null){
			//Throw.If(!Combinations.isProperComb(comb, _numNodes),
			//		"h function received illegal combination as argument.");
			int len = comb.length;
			val=0;
			int j=0;
			double denom=10;
			while(j<len){
				val += getNonCanonicalName(node, comb[j])/denom;
				j++;
				denom *=10;
			}
		}else{//comb==null when choose 0 out of non-empty set
			val = 1.0/(node+1);
		}
		return val;		
	}
	/**
	 * 
	 */
    public static void main(String[] args){
    	int numNodes = 6;
    	int combLen = 5;//must be >=1, <=numNodes-1
    	
    	int[][] combs = Combinations.getCombinations(combLen, numNodes-1);
    	Jen_hFun hFun = new Jen_hFun(numNodes);
    	int numCombs;
    	
    	numCombs = combs.length;
    	for(int node=0; node<numNodes; node++){
    		for(int com=0; com<numCombs; com++){
    			System.out.println(node + "," + hFun.h(node, combs[com]));
    		}
    	}
    		
    }
}
