import java.awt.*;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.ItemEvent;
import java.awt.event.ItemListener;

import javax.swing.*;
import javax.swing.border.LineBorder;
import javax.swing.border.TitledBorder;

/**
 * This class defines the GUI for the main and 
 * only window (Control Panel) of qMean.
 * 
 * Dec 9, 2013: Eclipse sdk70 bug. 
 * printf() invoked from applet puts files in qMean/bin,
 * whereas if use printf() in application puts files in qMean. 
 */
public class MeanApplet extends JApplet{
	
	private JTextField	_TF_filePrefix;
	
	private static int NUM_ROWS =4;
	private JComboBox _CB_numPsiBits = new JComboBox(new Object[]
			{"1","2","3","4"});
	
	
 	private JTextField	_TF_estP1overP0;	
	private JTextField	_TF_maxNumGroverSteps;
	private JTextField	_TF_gamTol;
	private JTextField 	_TF_deltaLam;

	
	private JButton		_B_computeSEO;
	
	private JTextField	_TF_prob0;
	private JTextField	_TF_gam0;
	private JTextField	_TF_finGamma;
	private JTextField	_TF_numGroverSteps;
	private JTextField  _TF_numBits;
	private JTextField	_TF_lenOfSEO;
//	private JTextField	_TF_error;
		

	private int _numPsiBits;
		
	/**
	 * 
	 */
	public void init(){

		_TF_filePrefix = new JTextField();
		
		_numPsiBits =1;
		_CB_numPsiBits.setSelectedIndex(0);
		
		_TF_estP1overP0 = new JTextField();
		
		_TF_maxNumGroverSteps = new JTextField();
		_TF_gamTol = new JTextField();
		_TF_deltaLam = new JTextField();

		
		_B_computeSEO = new JButton("Write Files");
		
		_TF_prob0 = new JTextField();
			_TF_prob0.setEditable(false);
		_TF_gam0 = new JTextField();
			_TF_gam0.setEditable(false);
		_TF_finGamma = new JTextField();
			_TF_finGamma.setEditable(false);
		_TF_numGroverSteps = new JTextField();
			_TF_numGroverSteps.setEditable(false);
		_TF_numBits = new JTextField();
			_TF_numBits.setEditable(false);
		_TF_lenOfSEO = new JTextField();
			_TF_lenOfSEO.setEditable(false);
	//	_TF_error = new JTextField();
	//		_TF_error.setEditable(false);
		
		LineBorder borderStyle = new LineBorder(Color.black, 2);
		//	BevelBorder border = new BevelBorder(BevelBorder.RAISED);
		//	EtchedBorder border = new EtchedBorder();
		
		JPanel panHeader = new JPanel(new BorderLayout(2, 2));//hgap, vgap
		java.net.URL iconURL = getClass().getResource("qMean-logo.gif");
		JLabel L_image = new JLabel(new ImageIcon(iconURL));
		panHeader.add(L_image, BorderLayout.CENTER);
		panHeader.add(new JLabel(Globals.VERSION), BorderLayout.SOUTH);

		JPanel panPrelimButs = new JPanel(new GridLayout(1,2));
		panPrelimButs.add(new Label("Number of |psi> qubits"));
			panPrelimButs.add(_CB_numPsiBits);

		JPanel panPrelim = new JPanel(new BorderLayout(2, 2));//hgap, vgap
		panPrelim.add(new JLabel("File Prefix"), BorderLayout.WEST);
		panPrelim.add(_TF_filePrefix, BorderLayout.CENTER );
		panPrelim.add(panPrelimButs, BorderLayout.SOUTH);
						
		

		JPanel panInGrid = new JPanel(new GridLayout(5, 2));//rows, cols
		panInGrid.add(new JLabel("Estimate of |z_1|^2  /  |z_0^2|"));
			panInGrid.add(_TF_estP1overP0);
		panInGrid.add(new JLabel("Maximum Number of Grover Steps"));
			panInGrid.add(_TF_maxNumGroverSteps);
		panInGrid.add(new JLabel("Gamma Tolerance (degs)"));
			panInGrid.add(_TF_gamTol);		
		panInGrid.add(new JLabel("Delta Lambda (degs)"));
			panInGrid.add(_TF_deltaLam);

		JPanel panIn = new JPanel(new BorderLayout(2,2));//hgap, vgap;
		panIn.add(panPrelim, BorderLayout.NORTH);
		panIn.add(panInGrid, BorderLayout.SOUTH);
		panIn.setBorder(new TitledBorder(borderStyle,"Inputs"));
				
		
		JPanel panMid = new JPanel(new FlowLayout(FlowLayout.RIGHT, 20, 2));
		panMid.add(_B_computeSEO);
	
		JPanel panOut = new JPanel(new GridLayout(6, 2));//rows, cols
		panOut.add(new JLabel("|z_0|^2"));
			panOut.add(_TF_prob0);
		panOut.add(new JLabel("Starting Gamma (degs)"));
			panOut.add(_TF_gam0);
		panOut.add(new JLabel("Final Gamma (degs)"));
			panOut.add(_TF_finGamma);
		panOut.add(new JLabel("Number of Grover Steps "));
			panOut.add(_TF_numGroverSteps);
		panOut.add(new JLabel("Number of Qubits"));
			panOut.add(_TF_numBits);
		panOut.add(new JLabel("Number of Elem. Ops."));
			panOut.add(_TF_lenOfSEO);
//		pan5.add(new JLabel("Error"));
//			pan5.add(_TF_error);
		panOut.setBorder(new TitledBorder(borderStyle, "Outputs"));


		JPanel panMidOut = new JPanel(new BorderLayout(2, 2));//hgap, vgap;
		panMidOut.add(panMid, BorderLayout.NORTH);
		panMidOut.add(panOut, BorderLayout.CENTER);

		setLayout(new BorderLayout(2, 2));//hgap, vgap;
		add(panHeader, BorderLayout.NORTH);
		add(panIn, BorderLayout.CENTER);
		add(panMidOut, BorderLayout.SOUTH);

		_CB_numPsiBits.addItemListener(new NumPsiBitsComboListener());
		_B_computeSEO.addActionListener(new WriteQfilesButtonListener());
	}
	/**
	 * 
	 */	
	private void clearOutputTextFields(){
		_TF_prob0.setText("");
		_TF_gam0.setText("");
		_TF_finGamma.setText("");
		_TF_numGroverSteps.setText("");
		_TF_numBits.setText("");
		_TF_lenOfSEO.setText("");
//		_TF_error.setText("");
	}
	/**
	 *
	 */
	private class NumPsiBitsComboListener implements ItemListener{
		public void itemStateChanged(ItemEvent eve) {
			_numPsiBits = _CB_numPsiBits.getSelectedIndex()+1;
			clearOutputTextFields();
		}
	}	
	/**
	 *
	 */
	private class WriteQfilesButtonListener implements ActionListener{
		public void actionPerformed(ActionEvent eve) {
			try{
				if(	_TF_filePrefix.getText().length()==0 ||
					_TF_estP1overP0.getText().length()==0||
					_TF_maxNumGroverSteps.getText().length()==0||
					_TF_gamTol.getText().length()==0 ||
					_TF_deltaLam.getText().length()==0){ 
					throw new Exception();
				}
				String filePrefix = _TF_filePrefix.getText();
				double estP1overP0 =  Double.parseDouble(
						_TF_estP1overP0.getText());				
				
				int maxNumGroverSteps = Integer.parseInt(
						_TF_maxNumGroverSteps.getText());
				double gamTol =  Double.parseDouble(
						_TF_gamTol.getText())*Math.PI/180;
				double deltaLam =  Double.parseDouble(
						_TF_deltaLam.getText())*Math.PI/180;
							
				MeanMain  m = new MeanMain(
					    filePrefix,
						_numPsiBits,
						estP1overP0,
					    maxNumGroverSteps,
						-1,//calculate true gam0
						gamTol,
					    deltaLam);
				double  prob_st = m.getP0()*(1 + estP1overP0);
				double 	gam0 = 2*Math.acos(Math.sqrt(prob_st));
				_TF_prob0.setText(String.format("%e",m.getP0()));
				_TF_gam0.setText(String.format("%e", gam0*180/Math.PI));
				_TF_finGamma.setText(String.format("%e", m.getFinGamma()*180/Math.PI));
				_TF_numGroverSteps.setText(String.format("%d", m.getNumGroverSteps()));
				
				int numBits = MeanMain.calcNumBits(_numPsiBits);
				_TF_numBits.setText(String.format("%d", numBits));
				_TF_lenOfSEO.setText(String.format("%d", m.getLenOfSEO()));
//				_TF_error.setText(String.format("%e", m.getError()));
			}
			catch(Exception ex){
				clearOutputTextFields();
				JOptionPane.showMessageDialog(null, 
						"qMean got BAD INPUT:\n" + ex.toString());
				return;
			}
		}
	}
	/**
	 *
	 */
	public static void main(String[] args) {
	    
	    JFrame frame = new JFrame("qMean");

	    
	    MeanApplet applet = new MeanApplet();

	    frame.add(applet, BorderLayout.CENTER);

	    applet.init();

	    //frame.setLocationRelativeTo(null); // Center the frame
	    frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);	    
	    frame.pack();
	    //frame.setSize(400, 250);
	    frame.setVisible(true);
	  }
}



