import java.awt.*;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.ItemEvent;
import java.awt.event.ItemListener;

import javax.swing.*;
import javax.swing.border.LineBorder;
import javax.swing.border.TitledBorder;


/**
 * This class defines the GUI for the main and 
 * only window (Control Panel) of qSym
 * 
 * Dec 9, 2013: Eclipse sdk70 bug. 
 * printf() invoked from applet puts files in qSym/bin,
 * whereas if use printf() in application puts files in qSym. 
 */
public class SymApplet extends JApplet{
	
	private JTextField	_TF_filePrefix;
	
	private static int MIN_DIT=2;
	private static int NUM_ROWS =4;
	private JComboBox _CB_numQudits = new JComboBox(new Object[]
			{"2","3","4"});
	
	private static int NUM_COLS =3;
	private JComboBox _CB_bitsPerDit = new JComboBox(new Object[]
			{"1","2","3"});	
	private JRadioButton[][]	_RB_cMat =
			new JRadioButton[NUM_ROWS][NUM_COLS];
	
	private JButton		_B_random_cMat;
	
 	private JTextField	_TF_estP1overP0;	
	private JTextField	_TF_maxNumGroverSteps;
	private JTextField	_TF_gamTol;
	private JTextField 	_TF_deltaLam;

	
	private JButton		_B_computeSEO;
	
	private JTextField	_TF_prob0;
	private JTextField	_TF_gam0;
	private JTextField	_TF_finGamma;
	private JTextField	_TF_numGroverSteps;
	private JTextField  _TF_numBits;
	private JTextField	_TF_lenOfSEO;
//	private JTextField	_TF_error;
		

	private int _numQudits;
	private int _bitsPerDit;
		
	/**
	 * 
	 */
	public void init(){

		_TF_filePrefix = new JTextField();
		
		_numQudits=MIN_DIT;
		_bitsPerDit=1;
		_CB_numQudits.setSelectedIndex(0);
		_CB_bitsPerDit.setSelectedIndex(0);
		for(int c=0; c<NUM_COLS; c++){
			for(int r=0; r<NUM_ROWS; r++){
				_RB_cMat[r][c]=new JRadioButton();
			}			
		}
		set_cMatRadioButtons(_numQudits, _bitsPerDit, false);
		
		_B_random_cMat = new JButton("Random c Matrix");

		_TF_estP1overP0 = new JTextField();
		
		_TF_maxNumGroverSteps = new JTextField();
		_TF_gamTol = new JTextField();
		_TF_deltaLam = new JTextField();

		
		_B_computeSEO = new JButton("Write Files");
		
		_TF_prob0 = new JTextField();
			_TF_prob0.setEditable(false);
		_TF_gam0 = new JTextField();
			_TF_gam0.setEditable(false);
		_TF_finGamma = new JTextField();
			_TF_finGamma.setEditable(false);
		_TF_numGroverSteps = new JTextField();
			_TF_numGroverSteps.setEditable(false);
		_TF_numBits = new JTextField();
			_TF_numBits.setEditable(false);
		_TF_lenOfSEO = new JTextField();
			_TF_lenOfSEO.setEditable(false);
	//	_TF_error = new JTextField();
	//		_TF_error.setEditable(false);
		
		LineBorder borderStyle = new LineBorder(Color.black, 2);
		//	BevelBorder border = new BevelBorder(BevelBorder.RAISED);
		//	EtchedBorder border = new EtchedBorder();
		
		JPanel panHeader = new JPanel(new BorderLayout(2, 2));//hgap, vgap
		java.net.URL iconURL = getClass().getResource("qSym-logo.gif");
		JLabel L_image = new JLabel(new ImageIcon(iconURL));
		panHeader.add(L_image, BorderLayout.CENTER);
		panHeader.add(new JLabel(Globals.VERSION), BorderLayout.SOUTH);

		JPanel panPrelimButs = new JPanel(new GridLayout(2,2));
		panPrelimButs.add(new Label("Number of Qudits"));
			panPrelimButs.add(_CB_numQudits);
		panPrelimButs.add(new Label("Sub-qubits Per Qudit"));
			panPrelimButs.add(_CB_bitsPerDit);

		JPanel panPrelim = new JPanel(new BorderLayout(2, 2));//hgap, vgap
		panPrelim.add(new JLabel("File Prefix"), BorderLayout.WEST);
		panPrelim.add(_TF_filePrefix, BorderLayout.CENTER );
		panPrelim.add(panPrelimButs, BorderLayout.SOUTH);
						
		JPanel panCmatRows = new JPanel(
				new GridLayout(NUM_ROWS+1,NUM_COLS + 1,2,2));
		int r,c;
		panCmatRows.add(new JLabel(" "));
		for(c=0; c<NUM_COLS; c++){
			panCmatRows.add(new JLabel("sub " + c));
		}
		for(r=0; r<NUM_ROWS; r++){
			panCmatRows.add(new JLabel("dit " + r));
			for(c=0; c<NUM_COLS; c++){
				panCmatRows.add(_RB_cMat[r][c]);
			}
		}
		
		JPanel panCmatBut = new JPanel(new FlowLayout(FlowLayout.RIGHT, 20, 2));
		panCmatBut.add(_B_random_cMat);

		JPanel pan_cMatFull = 
			new JPanel(new BorderLayout(2,1));	
		pan_cMatFull.add(panCmatRows,BorderLayout.CENTER );
		pan_cMatFull.add(panCmatBut, BorderLayout.SOUTH);
		pan_cMatFull.setBorder(new TitledBorder("c matrix"));

		JPanel panInGrid = new JPanel(new GridLayout(5, 2));//rows, cols
		panInGrid.add(new JLabel("Estimate of |z_1|^2  /  |z_0^2|"));
			panInGrid.add(_TF_estP1overP0);
		panInGrid.add(new JLabel("Maximum Number of Grover Steps"));
			panInGrid.add(_TF_maxNumGroverSteps);
		panInGrid.add(new JLabel("Gamma Tolerance (degs)"));
			panInGrid.add(_TF_gamTol);		
		panInGrid.add(new JLabel("Delta Lambda (degs)"));
			panInGrid.add(_TF_deltaLam);

		JPanel panIn = new JPanel(new BorderLayout(2,2));//hgap, vgap;
		panIn.add(panPrelim, BorderLayout.NORTH);
		panIn.add(pan_cMatFull, BorderLayout.CENTER);
		panIn.add(panInGrid, BorderLayout.SOUTH);
		panIn.setBorder(new TitledBorder(borderStyle,"Inputs"));
				
		
		JPanel panMid = new JPanel(new FlowLayout(FlowLayout.RIGHT, 20, 2));
		panMid.add(_B_computeSEO);
	
		JPanel panOut = new JPanel(new GridLayout(6, 2));//rows, cols
		panOut.add(new JLabel("|z_0|^2"));
			panOut.add(_TF_prob0);
		panOut.add(new JLabel("Starting Gamma (degs)"));
			panOut.add(_TF_gam0);
		panOut.add(new JLabel("Final Gamma (degs)"));
			panOut.add(_TF_finGamma);
		panOut.add(new JLabel("Number of Grover Steps "));
			panOut.add(_TF_numGroverSteps);
		panOut.add(new JLabel("Number of Qubits"));
			panOut.add(_TF_numBits);
		panOut.add(new JLabel("Number of Elem. Ops."));
			panOut.add(_TF_lenOfSEO);
//		pan5.add(new JLabel("Error"));
//			pan5.add(_TF_error);
		panOut.setBorder(new TitledBorder(borderStyle, "Outputs"));


		JPanel panMidOut = new JPanel(new BorderLayout(2, 2));//hgap, vgap;
		panMidOut.add(panMid, BorderLayout.NORTH);
		panMidOut.add(panOut, BorderLayout.CENTER);

		setLayout(new BorderLayout(2, 2));//hgap, vgap;
		add(panHeader, BorderLayout.NORTH);
		add(panIn, BorderLayout.CENTER);
		add(panMidOut, BorderLayout.SOUTH);

		_CB_numQudits.addItemListener(new NumQuditsComboListener());
		_CB_bitsPerDit.addItemListener(new BitsPerDitComboListener());
		_B_random_cMat.addActionListener(new Random_cMatButtonListener());
		_B_computeSEO.addActionListener(new WriteQfilesButtonListener());
	}
	/**
	 * 
	 */	
	private void set_cMatRadioButtons(	
			int numQudits, 
			int bitsPerDit, 
			Boolean makeRand)
	{
		for(int c=0; c<NUM_COLS; c++){
			for(int r=0; r<NUM_ROWS; r++){
				if(r<numQudits && c<bitsPerDit){
					_RB_cMat[r][c].setVisible(true);
					if(makeRand){
						_RB_cMat[r][c].setSelected(Math.random()<.5);
					}else{
						_RB_cMat[r][c].setSelected(true);
					}
				}else{
					_RB_cMat[r][c].setVisible(false);				
				}
			}			
		}
	}
	/**
	 * 
	 */	
	private void clearOutputTextFields(){
		_TF_prob0.setText("");
		_TF_gam0.setText("");
		_TF_finGamma.setText("");
		_TF_numGroverSteps.setText("");
		_TF_numBits.setText("");
		_TF_lenOfSEO.setText("");
//		_TF_error.setText("");
	}
	/**
	 *
	 */
	private class NumQuditsComboListener implements ItemListener{
		public void itemStateChanged(ItemEvent eve) {
			_numQudits = _CB_numQudits.getSelectedIndex()+MIN_DIT;
			set_cMatRadioButtons(_numQudits, _bitsPerDit, false);
			clearOutputTextFields();
		}
	}	
	/**
	 *
	 */
	private class BitsPerDitComboListener implements ItemListener{
		public void itemStateChanged(ItemEvent eve) {
			_bitsPerDit = _CB_bitsPerDit.getSelectedIndex()+1;
			set_cMatRadioButtons(_numQudits, _bitsPerDit, false);
			clearOutputTextFields();
		}
	}
	/**
	 *
	 */
	private class Random_cMatButtonListener implements ActionListener{
		public void actionPerformed(ActionEvent eve) {
			set_cMatRadioButtons(_numQudits, _bitsPerDit, true);
			clearOutputTextFields();
		}
	}
	/**
	 *
	 */
	private class WriteQfilesButtonListener implements ActionListener{
		public void actionPerformed(ActionEvent eve) {
			try{
				if(	_TF_filePrefix.getText().length()==0 ||
					_TF_estP1overP0.getText().length()==0||
					_TF_maxNumGroverSteps.getText().length()==0||
					_TF_gamTol.getText().length()==0 ||
					_TF_deltaLam.getText().length()==0){ 
					throw new Exception();
				}
				String filePrefix = _TF_filePrefix.getText();
				Boolean[][] cMat = new Boolean[_numQudits][_bitsPerDit];
				for(int c=0; c<_numQudits; c++){
					for(int r=0; r<_bitsPerDit; r++){
						cMat[c][r]=_RB_cMat[c][r].isSelected();
					}
				}
				double estP1overP0 =  Double.parseDouble(
						_TF_estP1overP0.getText());				
				
				int maxNumGroverSteps = Integer.parseInt(
						_TF_maxNumGroverSteps.getText());
				double gamTol =  Double.parseDouble(
						_TF_gamTol.getText())*Math.PI/180;
				double deltaLam =  Double.parseDouble(
						_TF_deltaLam.getText())*Math.PI/180;
							
				SymMain  m = new SymMain(
					    filePrefix,
						cMat,
						estP1overP0,
					    maxNumGroverSteps,
						-1,//calculate true gam0
						gamTol,
					    deltaLam);
				double  prob_st = m.getP0()*(1 + estP1overP0);
				double 	gam0 = 2*Math.acos(Math.sqrt(prob_st));
				_TF_prob0.setText(String.format("%e",m.getP0()));
				_TF_gam0.setText(String.format("%e", gam0*180/Math.PI));
				_TF_finGamma.setText(String.format("%e", m.getFinGamma()*180/Math.PI));
				_TF_numGroverSteps.setText(String.format("%d", m.getNumGroverSteps()));
				
				int numBits = SymMain.calcNumBits(_numQudits, _bitsPerDit);
				_TF_numBits.setText(String.format("%d", numBits));
				_TF_lenOfSEO.setText(String.format("%d", m.getLenOfSEO()));
//				_TF_error.setText(String.format("%e", m.getError()));
			}
			catch(Exception ex){
				clearOutputTextFields();
				JOptionPane.showMessageDialog(null, 
						"qSym got BAD INPUT:\n" + ex.toString());
				return;
			}
		}
	}
	/**
	 *
	 */
	public static void main(String[] args) {
	    
	    JFrame frame = new JFrame("qSym");

	    
	    SymApplet applet = new SymApplet();

	    frame.add(applet, BorderLayout.CENTER);

	    applet.init();

	    //frame.setLocationRelativeTo(null); // Center the frame
	    frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);	    
	    frame.pack();
	    //frame.setSize(400, 250);
	    frame.setVisible(true);
	  }
}


